<template>
    <v-dialog v-model="dialog" @input="v => v || this.closeModal()" max-width="600px" v-if="loaded">
      <v-card>
        <v-card-title>
          <span class="headline">{{isEditMode ? "Modifier" : "Créer" + " un évènement"}} </span>
        </v-card-title>
        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="12">
                <v-text-field label="Titre de l'évènement *" required v-model="formEvent.title"></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field label="Description *"  required v-model="formEvent.description"></v-text-field>
              </v-col>
              <v-col cols="12" md="6">
                <DateTimePicker label="Date et heure de début" v-model="formEvent.startDate" @input ="val => formEvent.startDate = val"/>
              </v-col>
              <v-col cols="12" md="6">
                <DateTimePicker label="Date et heure de fin" v-model="formEvent.endDate" @input ="val => formEvent.endDate = val"/>
              </v-col>
            </v-row>
          </v-container>
          <p class="text-danger" v-if="alertMessage !== ''">{{alertMessage}}</p>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue darken-1" :ripple="false" text @click="closeModal()">Retour</v-btn>
          <v-btn color="blue darken-1" :ripple="false" text @click="submitForm()">Sauvegarder</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
</template>

<script lang="ts">
import { Component, Vue, Watch, Prop } from 'vue-property-decorator';
import EventService from '../../services/eventService'
import { Event } from '../../transport/Event';
import CalendarEvent from '../../transport/CalendarEvent';
import DateTimePicker from './DateTimePicker.vue'

@Component({components: { DateTimePicker }})
export default class EditEventModal extends Vue{
  private formEvent: Event = null;
  private loaded: boolean = false;
  private _eventService: EventService = null;
  private alertMessage: string = "";
  @Prop({ default: null }) private event: CalendarEvent;
  @Prop ({ default: false}) private dialog: Boolean;

  get isEditMode(): boolean{
    return this.event !== null
  }

  mounted(){
    this.createFormEvent()
    this._eventService = new EventService();
    this.loaded = true;
  }

  /**
   * Créer un objet event utilisable pour le formulaire.
   */
  createFormEvent(){
    if(!this.isEditMode){
      // On créé à l'heure pile, pas besoin des minutes.
      this.formEvent = new Event({startDate: this.roundMinutes(new Date(), false), 
      endDate: this.roundMinutes(new Date(), true), 
      title:"", 
      description:""});
    }else{
      this.formEvent = this.event.data;
      // Fix d'un truc chelou
      this.formEvent.startDate = new Date(this.event.data.startDate)
      this.formEvent.endDate = new Date(this.event.data.endDate)
    }
  }
  @Watch('formEvent', { deep: true })
  // onStartDateChange(val, oldVal){
  onStartDateChange() {
    if (this.formEvent.startDate > this.formEvent.endDate) {
      this.formEvent.endDate = new Date(this.formEvent.startDate.getTime() + (5 * 60000)) ;
    }
    this.alertMessage = this.formEvent.startDate > this.formEvent.endDate ?
    "La date de fin ne peut pas être inférieure à la de début." :
    "";
  }
  roundMinutes(date: Date, addFive: boolean) {
      date.setHours(date.getHours() + 1);
      date.setMinutes(addFive ? 5 : 0);
      return date;
  }
  submitForm(){
    if(this.alertMessage === ""){
      if (this.isEditMode) {
        this._eventService.updateEvent(this.formEvent)
        .then(() => { this.closeModal() })
        .catch(err => {(this as any).$noty.error(err.message)})
      }else{
        this._eventService.addEvent(this.formEvent)
        .then(() => { this.closeModal() })
        .catch(err => (this as any).$noty.error(err.message))
      }
    }
  }

  closeModal(){
    this.$emit("isClose")
  }

  verifyDates(): boolean{
    if(this.formEvent.startDate > this.formEvent.endDate)
      return false;
    if(!this.alertMessage)
      return false;
    return true
  }

  get nowTime(): Date{
    return new Date();
  }
}
</script>
